/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function CODE_Monitor		//<c><a>public<d>Code panel monitor class
(
_mediator,		//<p>GUI_Mediator<d>Application mediator instance
_editorId		//<p>string<d>Editor element ID
){
//================
this.CODE_Monitor = function		//<m>void<a>private<d>class constructor
(
mediator,		//<p>GUI_Mediator<d>Application mediator instance
editorId		//<p>string<d>Editor element ID
){
this.prototype = CONTENT_Monitor;
this.prototype(mediator, editorId, XC.K.CODE_LABEL);
this.className	= 'CODE_Monitor';
this.setController();
}//</m>CODE_Monitor



//================
this.setController = function		//<m>void<a>private<d>Controller i12n
(){
this.storeController = new CODE_storeController(this.mediator);
}//</m>setController



//================
this.setAddStoreItem = function		//<m>void<a>public<d>Add selected code to store
(){
var
/*string*/code = this.mediator.dom.getElement(this.editorId).contentWindow.getSelection().toString();
this.storeController.setAddItem(code);
}//</m>setAddStoreItem



//================
this.setRemoveStoreItem = function		//<m>void<a>public<d>Remove code from store
(){
this.storeController.setRemoveItem();
}//</m>setRemoveStoreItem



//================
this.setPasteStoreItem = function		//<m>void<a>public<d>Paste code from store
(){
var
/*string*/code = this.storeController.getItem();
if(code != '') this.setContent(code);
}//</m>setPasteStoreItem



//================
this.setRunCode = function		//<m>string<a>public<d>Evaluate code
(
code		//<p>string<d>Code to evaluate --optional
){
try{
	var
	/*string*/source = this.getSource(code || this.controller.getContent()),
	/*Date*/start = new Date();
	this.mediator.setOut(source);
	var
	/*Date*/stop = new Date();
	this.execTime = stop - start;
	return '';
	}
catch(e){
	return e;
	}
}//</m>setRunCode



//================
this.getSource = function		//<m>string<a>private<d>Get source sourcePath
(
code		//<p>string<d>Code to evaluate --optional
){
return this.testProtocol(code) || this.getLocalPath(this.mediator.getCodeLastLoad());
}//</m>getSource



//================
this.getLocalPath = function		//<m>string<a>private<d>Get the local path for a source
(
path		//<p>string<d>Source path
){
return XC.K.FILE_PROTOCOL + path;
}//</m>getLocalPath



//================
this.getExecTime = function		//<m>string<a>public<d>Get execution time in seconds
(){
var
/*int*/time = this.execTime / 1000,
/*string*/timeString = time.toString(),
/*string[]*/numberSet = timeString.match(/(\d+).(\d+)/);
if(numberSet){
	var
	/*string*/milliseconds = numberSet[2];
	if(milliseconds.length < 3) milliseconds += '0';
	if(milliseconds.length < 3) milliseconds += '0';
	timeString = numberSet[1] + '.' + milliseconds;
	}
return timeString;
}//</m>getExecTime


//================
this.testProtocol = function		//<m>(boolean)string<a>private<d>Check wether code is actually a protocol (file, chrome or http)
(
code		//<p>string<d>Code to evaluate
){
try{
	return code.match(XC.K.xul.PROTOCOL_PATTERN)[0];
	}
catch(e){
	return '';
	}
}//</m>testProtocol



this.CODE_Monitor(_mediator, _editorId);
}//</c>CODE_Monitor

