/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function GUI_Mediator		//<c><a>public<d>Application mediator class
(){
//================
this.GUI_Mediator = function		//<m>void<a>private<d>class constructor
(){
this.className	= 'GUI_Mediator';
this.set_GUI_Mediator();
}//</m>GUI_Mediator



//================
this.set_GUI_Mediator = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.dom			= new DOM_Monitor();
this.tab			= this.dom.getElement(XC.K.xul.APP_TABS_ID);
this.bundler		= this.dom.getElement(XC.K.xul.APP_BUNDLE_ID);
this.prefsMonitor	= new PREFS_Monitor(this);
this.codeMonitor	= new CODE_Monitor(this, XC.K.xul.CODE_EDITOR_ID);
this.outMonitor		= new OUT_Monitor(this, XC.K.xul.OUT_IFRAME_ID);
this.errorMonitor	= new ERROR_Monitor(this, XC.K.xul.ERROR_EDITOR_ID);
this.errorTracer	= new ERROR_Tracer();
this.reloading		= true;
this.setTab(XC.K.xul.CODE_TAB);
this.setLoad(this.getPref('code', 'url'));
}//</m>set_GUI_Mediator



//================
this.setTab = function		//<m>void<a>public<d>Set up tab panel
(
tabIndex,		//<p>int<d>Tab index
status			//<p>string<d>Status message --optional
){
try{
	this.tab.selectedIndex = tabIndex;
	this.setStatus(status);
	}
catch(e){ }
}//</m>setTab



//================
this.setStatus = function		//<m>void<a>private<d>Set up status panel
(
status		//<p>string<d>Status message --optional
){
var
/*int*/at = this.tab.selectedIndex;
if((at < XC.K.gui.STATUS_BUNDLE_SET.length) && !status) status = this.getBundleString(XC.K.gui.STATUS_BUNDLE_SET[at]);
if(status){
	var
	/*Object*/statusNode = this.dom.getElement(XC.K.xul.STATUS_ID);
	statusNode.setAttribute('label', status);
	statusNode.setAttribute('class', XC.K.gui.STATUS_CLASS_SET[at]);
	}
}//</m>setStatus



//================
this.setCode = function		//<m>void<a>public<d>Output API function to code panel
(
output,			//<p>string<d>Content to output
replacing		//<p>boolean<d>Replacing content flag: replace || append --optional
){
this.codeMonitor.setContent(output, replacing);
}//</m>setCode



//================
this.setOut = function		//<m>void<a>public<d>Output to output panel
(
output,			//<p>string<d>Content to output
replacing		//<p>boolean<d>Replacing content flag: replace || append --optional
){
this.outMonitor.setContent(output, replacing);
}//</m>setOut



//================
this.setClear = function		//<m>void<a>public<d>Output to output panel
(){
this[this.K.MONITOR_SET[this.tab.selectedIndex]].setContent('', XC.K.gui.REPLACE_CONTENT);
}//</m>setClear



//================
this.setCommand = function		//<m>void<a>public<d>Output to output panel
(
tabIndex,		//<p>int<d>Tab index
command,		//<p>string<d>Command name
arg				//<p>string<d>Command argument --optional
){
this[this.K.MONITOR_SET[tabIndex]].setCommand(command, arg);
}//</m>setCommand



//================
this.setLoad = function		//<m>void<a>public<d>Load a (JS script) file in panel content
(
path				//<p>string<d>Last loading file --optional
){
if(!path && !(path = this.getFilePath())) return;
if(this.tab.selectedIndex == XC.K.xul.CODE_TAB){
	this[this.K.MONITOR_SET[this.tab.selectedIndex]].set_lastLoad(path);
	this.setPref(path, 'code', 'url');
	}
var
/*IO_file_fileInstantiator*/file = new IO_file_fileInstantiator();
if(file.set_handle(path, 0644) != this.K.ERROR.NONE) return;		//FIXME: we should have an alert
this.setCode(file.getIn(), XC.K.gui.REPLACE_CONTENT);
file.set_handle();
}//</m>setLoad



//================
this.setReload = function		//<m>void<a>public<d>Reload previously loaded (JS script) file in panel content
(){
this.setLoad(this.getCodeLastLoad());
}//</m>setReload



//================
this.setPeriodicTable = function		//<m>void<a>public<d>Load XUL Periodic table file in panel content
(){
this.setLoad(this.getSamplesDir() + XC.K.xul.PERIODIC_TABLE_PATH);
}//</m>setPeriodicTable



//================
this.setSample = function		//<m>void<a>public<d>Load XUL sample file in panel content
(){
this.setLoad(this.getSamplesFilePath());
}//</m>setSample



//================
this.setSave = function		//<m>string<a>public<m>Save a panel content to a file
(){
return this.setSaveAs(this[this.K.MONITOR_SET[this.tab.selectedIndex]].get_lastSave());
}//</m>setSave



//================
this.setSaveAs = function		//<m>string<a>public<m>Save a panel content to a file choosen with the filepicker
(
path				//<p>string<d>Last loading file --optional
){
if(!path && !(path = this.getFilePath('SAVING'))) return;
if(this.tab.selectedIndex == XC.K.xul.CODE_TAB) this[this.K.MONITOR_SET[this.tab.selectedIndex]].set_lastSave(path);
var
/*IO_file_fileInstantiator*/file = new IO_file_fileInstantiator();
if(file.set_handle(path, 0644) != this.K.ERROR.NONE) return;		//FIXME: we should have an alert
var
/*string*/content = this[this.K.MONITOR_SET[this.tab.selectedIndex]].getContent();
file.setOut(content);
file.set_handle();
return path;
}//</m>setSaveAs



//================
this.setRunCode = function		//<m>int<a>public<d>Evaluate code
(
code		//<p>string<d>Code to evaluate --optional
){
var
/*int*/tabIndex = XC.K.xul.ERROR_TAB,		//default to error!
/*string*/status = null,
/*string*/output = this.codeMonitor.setRunCode(code) + this.errorTracer.get_trace();
if(output) this.errorMonitor.setContent(Stdout.setOut('%N', output));
else{
	tabIndex = XC.K.xul.OUT_TAB;
	status = sprintf(this.getBundleString(XC.K.gui.STATUS_BUNDLE_SET[tabIndex]), this.codeMonitor.getExecTime());
	}
this.trace = '';	//clear
this.setTab(tabIndex, status);
}//</m>setRunCode


//================
this.setAddStoreItem = function		//<m>void<a>public<d>Add selected code to store
(){
this.codeMonitor.setAddStoreItem();
this.setTab(XC.K.xul.STORE_TAB);
}//</m>setAddStoreItem



//================
this.setRemoveStoreItem = function		//<m>void<a>public<d>Remove code from store
(){
this.codeMonitor.setRemoveStoreItem();
}//</m>setRemoveStoreItem



//================
this.setPasteStoreItem = function		//<m>void<a>public<d>Paste code from store
(){
this.codeMonitor.setPasteStoreItem();
this.setTab(XC.K.xul.CODE_TAB);
}//</m>setPasteStoreItem



//================
this.setHelpURL = function		//<m>void<a>public<d>Select help panel
(
url		//<p>string<d>Help document URL
){
this.dom.setAttribute(XC.K.xul.HELP_IFRAME_ID, 'src', url);
if(!this.testtHelpTab()) this.setTab(XC.K.xul.HELP_TAB);
}//</m>setHelpURL



//================
this.setBrowserTest = function		//<m>void<a>public<d>Load the content of the Unit test panel in the browser window
(){
var
/*string*/path = this.setSaveAs();
if(path) this.setBrowserLocation('file://' + path);
}//</m>setBrowserTest



//================
this.setBrowserHelp = function		//<m>void<a>public<d>Load an help page in the browser window
(){
var
chromeDir = this.getChromeDir().path,
src = this.dom.getAttribute(XC.K.xul.HELP_IFRAME_ID, 'src'),
locale = this.prefsMonitor.getBrowserLocale(),
url = 'file://' + chromeDir + src.substr('chrome:/'.length).replace(/locale/, 'locale/' + locale);
this.setBrowserLocation(url);
}//</m>setBrowserHelp



//================
this.setBrowserLocation = function		//<m>void<a>public<d>Load an URL in the browser window
(
url		//<p>string<d>URL to load
){
if(window.opener && !window.opener.closed) window.opener._content.location = url;
}//</m>setBrowserLocation



//================
this.setSavingDir = function		//<m>void<a>public<d>Setup a directory for saving
(
target		//<p>string<d>Target editor name (code, output...)
){
var
/*Object*/handle = this.getDirHandle();
if(!handle) return;
this.prefsMonitor.setSavingDir(target, handle);
}//</m>setSavingDir



//================
this.setPreferences = function		//<m>void<a>public<d>Save preferences
(){
this.prefsMonitor.setPreferences();
for(var i=0,m=XC.K.EDITOR_SET.length;i<m;i++){
	this[this.K.MONITOR_SET[i]].setStyle();
	this[this.K.MONITOR_SET[i]].set_outputHeader();
	}
}//</m>setPreferences



//================
this.setPref = function		//<m>string<a>public<d>Set up a global preference
(
value,		//<p>any<d>Preference value
pref,		//<p>string<d>Preference
property,	//<p>string<d>Preference property
target		//<p>string<d>Target editor name (code, output...)
){
return this.prefsMonitor.setPref(value, pref, property, target);
}//</m>setPref



//================
this.getPref = function		//<m>string<a>public<d>Get global preference
(
pref,		//<p>string<d>Preference
property,	//<p>string<d>Preference property
target		//<p>string<d>Target editor name (code, output...)
){
return this.prefsMonitor.getPref(pref, property, target);
}//</m>getPref



//================
this.getTrace = function		//<m>string<a>public<d>Get trace
(
exception,		//<p>string<d>Exception thrown
traceStop		//<p>string<d>Calling function name where to stop tracing --optional
){
this.errorTracer.set_trace(exception, traceStop);
return this.errorTracer.get_trace();
}//</m>setTrace



//================
this.getDirHandle = function		//<m>string<a>private<d>Get a directory handle for loading/saving
(){
var
/*IO_selector_Selector*/selector = new IO_selector_Selector(
	this.getBundleString('xc.filepicker.dir.label'),
	'modeGetFolder',
	{
	label:		'WHAT IS IT ?',
	flagSet: 	['filterAll']
	}
	);
selector.setDialog();
return selector.getHandle();
}//</m>getDirHandle



//================
this.getFilePath = function		//<m>stringa>private<d>Get a file path for loading or saving
(
saving		//<p>boolean<d>Saving flag: save || load
){
var
/*IO_selector_Selector*/selector = new IO_selector_Selector(
	this.getBundleString('xc.filepicker.file.label'),
	saving ? 'modeSave' : 'modeOpen',
	{
	label:		'WHAT IS IT ?',
	flagSet: 	['filterAll']
	}
	);
selector.setDirPath(this.getPref('path', 'dir', XC.K.EDITOR_SET[this.tab.selectedIndex]));
selector.setDialog();
return selector.getPath();
}//</m>getFilePath



//================
this.getSamplesFilePath = function		//<m>stringa>private<d>Get a file path from samples directory for loading
(){
var
/*IO_selector_Selector*/selector = new IO_selector_Selector(
	this.getBundleString('xc.filepicker.file.label'),
	'modeOpen',
	{
	label:		'WHAT IS IT ?',
	flagSet: 	['filterXUL']
	}
	);
var
/*IO_file_fileInstantiator*/file = new IO_file_fileInstantiator();
if(file.set_handle(this.getSamplesDir(), 0644) != this.K.ERROR.NONE) return;		//FIXME: we should have an alert
selector.setDirPath(file.get_handle());
selector.setDialog();
return selector.getPath();
}//</m>getSamplesFilePath



//================
this.getMozDir = function		//<m>Object<a>public<d>Get a Mozilla directory
(
dirKey		//<p>String<d>Mozilla directory key (see handlers.js)
){
var
/*IO_file_dirInstantiator*/IODir = new IO_file_dirInstantiator();
return IODir.getMozHandle(XPConnector.K.mozDirSet[dirKey]);
}//</m>getMozDir



//================
this.getChromeDir = function		//<m>Object<a>public<d>Get Mozilla chrome directory
(){
return this.getMozDir('moz_chrome');
}//</m>getChromeDir



//================
this.getSamplesDir = function		//<m>void<a>public<d>Get XUL samples directory path
(){
return this.getChromeDir().path + XC.K.xul.SAMPLES_DIR;
}//</m>getSamplesDir



//================
this.getUserDir = function		//<m>Object<a>public<d>Get user home directory
(){
return this.getMozDir('profile_root').parent;			//Mozilla dir is under user home dir
}//</m>getUserDir



//================
this.getUserProfileDir = function		//<m>Object<a>public<d>Get user profile directory
(){
return this.getMozDir('profile_chrome').parent;			//Profile chrome dir is under profile dir
}//</m>getUserProfileDir



//================
this.getUserPath = function		//<m>int<a>private<d>Get path of xulconsoleuser.asrdf file
(){
try{
	var
	/*string*/profileDir = this.getUserProfileDir().path;
	if(!profileDir) throw this.K.ERROR.JS_USER_IMPORT;
	var
	/*string*/pathSeparator = (profileDir.indexOf('\\') != -1) ? '\\' :
		(profileDir.indexOf(':') != -1) ? ':' : '/';
	return (profileDir + pathSeparator + XC.K.USER_LEAF);
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.JS_USER_IMPORT);
	return '';
	}
}//</m>getUserPath



//================
this.getBundleString = function		//<m>string<a>public<d>Get bundle element string
(
property		//<p>string<d>Property identifier
){
return this.bundler.getString(property);
}//</m>getBundleString



//================
this.getXPCOM = function		//<m>Object<a>public<d>Get an instance or a constructor of an XPCOM object
(
intrface,		//<p>string<d>Interface
component,		//<p>boolean<d>Replacing content flag: replace || append --optional
serving			//<p>boolean<d>Service flag: service || instance
){
if(!(intrface in XPConnector.K)) XPConnector.K[intrface] = component;
try{
	var
	/*string*/method = serving ? 'getService' : 'getInstance';
	return XPConnector[method](intrface);
	}
catch(e){
	Stdout.setOut('EXCEPTION: %N', e);
	return null;
	}
}//</m>getXPCOM



//================
this.getStoreItem = function		//<m>void<a>public<d>Get code to insert in editor
(){
this.setTab(XC.K.xul.STORE_TAB);
}//</m>getStoreItem



//================
this.getCodeLastLoad = function		//<m>string<a>public<d>Get last loading path
(){
return this[this.K.MONITOR_SET[XC.K.xul.CODE_TAB]].get_lastLoad();
}//</m>getCodeLastLoad



//================
this.testtHelpTab = function		//<m>boolean<a>private<d>Check whether current tab is Help tab
(){
return this.tab.selectedIndex = XC.K.xul.HELP_TAB;
}//</m>testtHelpTab

 
this.K =
	{
	MONITOR_SET:				['codeMonitor', 'outMonitor', 'errorMonitor'],
	TRACE_ON:					true,
	TRACE_OFF:					false,

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		JS_USER_IMPORT:			-1,
		FATAL:					0xFF		//end of error codes
		}
	};



this.GUI_Mediator();
}//</c>GUI_Mediator



