/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function PREFS_Controller		//<c><a>protected<d>Preferences controller class
(
_mediator		//<p>GUI_Mediator<d>Application mediator instance
){
//================
this.PREFS_Controller = function		//<m>void<a>private<d>class constructor
(
mediator		//<p>GUI_Mediator<d>Application mediator instance
){
this.className	= 'PREFS_Controller';
this.mediator	= mediator;
this.set_PREFS_Controller();
}//</m>PREFS_Controller



//================
this.set_PREFS_Controller = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.setXPCOM();
this.fontPopup		= null;
this.setFontPopup();
}//</m>set_PREFS_Controller



//================
this.setXPCOM = function		//<m>void<a>private<d>SetUp Prefs service interface
(){
try{
	var
	/*Object*/fontList = XPConnector.getInstance('nsIFontList');
	this.fontEnum = fontList.availableFonts(this.K.FONT_LANG, this.K.FONT_TYPE)
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>setXPCOM



//================
this.setFontPopup = function		//<m>int<a>private<d>Setup a popup element with all fonts as menulistitem
(){
try{
	var
	/*string*/fontFace,
	/*Object*/itemNode,
	/*Object*/popupNode = this.mediator.dom.setNewElement('menupopup');
	while(this.fontEnum.hasMoreElements()){
		fontFace = XPConnector.getQuery('nsISupportsString', this.fontEnum.getNext()).toString();
		itemNode = document.createElement('menuitem');
		itemNode.setAttribute('value', fontFace);
		itemNode.setAttribute('label', fontFace);
		popupNode.appendChild(itemNode);
		}
	this.fontPopup = popupNode;
	return this.K.ERROR.NONE;
	}
catch(e){
	 return this.errorNotifier.setOut(e, this.K.ERROR.FONT_LIST_ENUMERATION);
	}
}//</m>setFontPopup



//================
this.setFontName = function		//<m>void<a>protected<d>Set up popup for font name selection
(
menulistNode,		//<p>Object<d>Menulist XUL element node
pref				//<p>string<d>Font name
){
const
/*boolean*/DEEP_COPY = true;
menulistNode.appendChild(this.fontPopup.cloneNode(DEEP_COPY));
var
/*Object*/itemNode,
/*Object*/popupNode = menulistNode.firstChild;
for(var i=0,m=popupNode.childNodes.length;i<m;i++){
	itemNode = popupNode.childNodes.item(i);
	if(itemNode.getAttribute('value') == pref){
		menulistNode.selectedIndex = i;
		break;
		}
	}	//---for
if(menulistNode.selectedIndex == -1) menulistNode.selectedIndex = 0;
}//</m>setFontName



//================
this.setFontSize = function		//<m>void<a>protected<d>Set up popup for font name selection
(
menulistNode,		//<p>Object<d>Menulist XUL element node
pref				//<p>string<d>Font size
){
var
/*Object*/itemNode,
/*Object*/popupNode = menulistNode.firstChild;
for(var i=0,m=popupNode.childNodes.length;i<m;i++){
	itemNode = popupNode.childNodes.item(i);
	if(itemNode.getAttribute('value') == pref){
		menulistNode.selectedIndex = i;
		break;
		}
	}	//---for
if(menulistNode.selectedIndex == -1) menulistNode.selectedIndex = 0;
}//</m>setFontSize



//================
this.setColorpicker = function		//<m>void<a>protected<d>Set up colorpicker for color selection
(
colorpicker,	//<p>Object<d>Colorpicker XUL element node
pref			//<p>string<d>Color hex
){
colorpicker.color = pref;
}//</m>setColorpicker



//================
this.setPathText = function		//<m>void<a>protected<d>Set up path textbox for path selection
(
textbox,		//<p>Object<d>Textbox XUL element node
pref			//<p>string<d>Path URL
){
textbox.value = pref;
}//</m>setPathText



//================
this.setStoreText = function		//<m>void<a>protected<d>Set up store textbox for store selection
(
textbox,		//<p>Object<d>Textbox XUL element node
pref			//<p>int<d>Store capacity
){
textbox.value = pref;
}//</m>setStoreText



//================
this.setOutputText = function		//<m>void<a>protected<d>Set up output header string textbox
(
textbox,		//<p>Object<d>Textbox XUL element node
pref			//<p>int<d>Store capacity
){
textbox.value = pref;
}//</m>setOutputText



//================
this.getFontName = function		//<m>string<a>protected<d>Get font name selection
(
menulistNode		//<p>Object<d>Menulist XUL element node
){
return menulistNode.value;
}//</m>getFontName



//================
this.getFontSize = function		//<m>string<a>protected<d>Get font size selection
(
menulistNode		//<p>Object<d>Menulist XUL element node
){
return menulistNode.value;
}//</m>getFontSize



//================
this.getColorpicker = function		//<m>string<a>protected<d>Get colorpicker value
(
colorpicker	//<p>Object<d>Colorpicker XUL element node
){
return colorpicker.color;
}//</m>getColorpicker



//================
this.getPathText = function		//<m>string<a>protected<d>Get path value
(
textbox		//<p>Object<d>Textbox XUL element node
){
return textbox.value;
}//</m>getPathText



//================
this.getStoreText = function		//<m>string<a>protected<d>Get store capacity value
(
textbox		//<p>Object<d>Textbox XUL element node
){
return textbox.value;
}//</m>getStoreText



//================
this.getOutputText = function		//<m>string<a>protected<d>Get output header string
(
textbox		//<p>Object<d>Textbox XUL element node
){
return textbox.value;
}//</m>getOutputText



this.K =
	{
	FONT_LANG:					'x-western',
	FONT_TYPE:					'monospace',
	
	xul:
		{
		},

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		SERVICE_ACCESS:			-1,
		FONT_LIST_ENUMERATION:	-2,
		FATAL:					0xFF		//end of error codes
		}
	};



this.PREFS_Controller(_mediator);
}//</c>PREFS_Controller

