/*
 * The contents of this file are
 * published under the Mozilla Public License 1.1
 */
//@@@@@@@@@@@@@@@@
function PREFS_Monitor		//<c><a>public<d>Preferences monitor class
(
_mediator		//<p>GUI_Mediator<d>Application mediator instance
){
//================
this.PREFS_Monitor = function		//<m>void<a>private<d>class constructor
(
mediator		//<p>GUI_Mediator<d>Application mediator instance
){
this.className	= 'PREFS_Monitor';
this.mediator	= mediator;
this.set_PREFS_Monitor();
}//</m>PREFS_Monitor



//================
this.set_PREFS_Monitor = function		//<m>void<a>private<d>Instance i12n
(){
this.errorNotifier	= new ERROR_Notifier(this.className);
this.setXPCOM();
this.controller		= new PREFS_Controller(this.mediator);
this.prefs			=
	{
	version:
		{
		release: 0,
		langSet: []
		},
	font:
		{
		name:	{},
		size:	{}
		},
	color:
		{
		bg:		{},
		fg:		{}
		},
	path:
		{
		dir:	{}
		},
	store:
		{
		capacity:	0,
		url:		''
		},
	output:
		{
		header: ''
		},
	code:
		{
		url: '',
		loading: true
		}
	};
this.prefs.version.langSet['en-US'] = true;
this.setInstallPrefs();
this.getPreferences();
this.setFontInputSet();
this.setColorInputSet();
this.setPathInputSet();
this.setStoreInput();
this.setOutputInput();
}//</m>set_PREFS_Monitor



//================
this.setInstallPrefs = function		//<m>void<a>private<d>Set up prefs after install
(){
var
/*int*/setting = this.testPrefsSetting();
if(setting == this.K.DEFAULT_SETTING) this.setUpPrefs();
else if(setting == this.K.UPDATE_SETTING) this.setUpPrefsUpdating();
}//</m>setInstallPrefs



//================
this.setXPCOM = function		//<m>void<a>private<d>SetUp Prefs service interface
(){
try{
	this.service	= XPConnector.getService('nsIPrefService');
	this.localFile	= XPConnector.getInterface('nsILocalFile');
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>setXPCOM



//================
this.setUpPrefs = function		//<m>int<a>private<d>Set up preferences
(
prefs		//<p>Object<d>User preferences --optional (only at install: default setting)
){
try{
	var
	/*string*/target,
	/*Object*/branch,
	/*Object*/browserPrefs = this.getBrowserPrefs();
	for(var i=0,m=XC.K.EDITOR_SET.length;i<m;i++){
		target = XC.K.EDITOR_SET[i];
		branch = this.service.getBranch(this.getBranchRoot(this.K.FONT_BRANCH, target));
		branch.setCharPref(this.K.FONT_NAME, prefs ? prefs.font.name[target] : browserPrefs.font);
		branch.setCharPref(this.K.FONT_SIZE, prefs ? prefs.font.size[target] : browserPrefs.size);
		branch = this.service.getBranch(this.getBranchRoot(this.K.COLOR_BRANCH, target));
		branch.setCharPref(this.K.COLOR_BG, prefs ? prefs.color.bg[target] : browserPrefs.bgcolor);
		branch.setCharPref(this.K.COLOR_FG, prefs ? prefs.color.fg[target] : browserPrefs.fgcolor);
		branch = this.service.getBranch(this.getBranchRoot(this.K.PATH_BRANCH, target));
		branch.setComplexValue(this.K.PATH_DIR, this.localFile, prefs ? prefs.path.dir[target] : this.mediator.getUserDir());
		}	//---for
	branch = this.service.getBranch(this.getBranchRoot(this.K.STORE_BRANCH, XC.K.CODE_LABEL));
	branch.setIntPref(this.K.STORE_CAPACITY, prefs ? prefs.store.capacity : this.K.STORE_CAPACITY_DEF);
	branch.setCharPref(this.K.STORE_URL, prefs ? prefs.store.url : this.getStoreURL());
	branch = this.service.getBranch(this.getBranchRoot(this.K.OUTPUT_BRANCH, XC.K.OUT_LABEL));
	branch.setCharPref(this.K.OUTPUT_HEADER, prefs ? prefs.output.header : this.K.OUTPUT_HEADER_DEF);
	branch = this.service.getBranch(this.getBranchRoot(this.K.CODE_BRANCH));
	//branch.setComplexValue(this.K.CODE_URL, this.localFile, prefs ? prefs.code.url : this.mediator.getUserImport());
	branch.setCharPref(this.K.CODE_URL, prefs ? prefs.code.url : this.mediator.getUserPath());
	branch.setBoolPref(this.K.CODE_LOADING, prefs ? prefs.code.loading : this.K.CODE_LOADING_DEF);
	branch = this.service.getBranch(this.getBranchRoot(this.K.VERSION_BRANCH));
	branch.setCharPref(this.K.VERSION_RELEASE, prefs ? prefs.version.release : XC.K.APP_VERSION);
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.PREFS_SETTING);
	}
}//</m>setUpPrefs



//================
this.setUpPrefsUpdating = function		//<m>void<a>private<d>Set up preference update
(){
this.getPreferences();
//setup new preferences
this.setUpPrefs(this.prefs);
}//</m>setUpPrefsUpdating



//================
this.setFontInputSet = function		//<m>void<a>private<d>Setup font pref widgets
(){
this.controller.setFontName(this.getElement(XC.K.xul.CODE_FONT_NAME_ID), this.prefs.font.name[XC.K.CODE_LABEL]);
//this.controller.setFontName(this.getElement(XC.K.xul.OUT_FONT_NAME_ID), this.prefs.font.name[XC.K.OUT_LABEL]);
this.controller.setFontName(this.getElement(XC.K.xul.ERROR_FONT_NAME_ID), this.prefs.font.name[XC.K.ERROR_LABEL]);

this.controller.setFontSize(this.getElement(XC.K.xul.CODE_FONT_SIZE_ID), this.prefs.font.size[XC.K.CODE_LABEL]);
//this.controller.setFontSize(this.getElement(XC.K.xul.OUT_FONT_SIZE_ID), this.prefs.font.size[XC.K.OUT_LABEL]);
this.controller.setFontSize(this.getElement(XC.K.xul.ERROR_FONT_SIZE_ID), this.prefs.font.size[XC.K.ERROR_LABEL]);
}//</m>setFontInputSet



//================
this.setColorInputSet = function		//<m>void<a>private<d>Setup color pref widgets
(){
this.controller.setColorpicker(this.getElement(XC.K.xul.CODE_COLOR_BG_ID), this.prefs.color.bg[XC.K.CODE_LABEL]);
//this.controller.setColorpicker(this.getElement(XC.K.xul.OUT_COLOR_BG_ID), this.prefs.color.bg[XC.K.OUT_LABEL]);
this.controller.setColorpicker(this.getElement(XC.K.xul.ERROR_COLOR_BG_ID), this.prefs.color.bg[XC.K.ERROR_LABEL]);

this.controller.setColorpicker(this.getElement(XC.K.xul.CODE_COLOR_FG_ID), this.prefs.color.fg[XC.K.CODE_LABEL]);
//this.controller.setColorpicker(this.getElement(XC.K.xul.OUT_COLOR_FG_ID), this.prefs.color.fg[XC.K.OUT_LABEL]);
this.controller.setColorpicker(this.getElement(XC.K.xul.ERROR_COLOR_FG_ID), this.prefs.color.fg[XC.K.ERROR_LABEL]);
}//</m>setColorInputSet



//================
this.setPathInputSet = function		//<m>void<a>private<d>Setup path pref widgets
(){
this.controller.setPathText(this.getElement(XC.K.xul.CODE_PATH_ID), this.prefs.path.dir[XC.K.CODE_LABEL].path);
//this.controller.setPathText(this.getElement(XC.K.xul.OUT_PATH_ID), this.prefs.path.dir[XC.K.OUT_LABEL].path);
this.controller.setPathText(this.getElement(XC.K.xul.ERROR_PATH_ID), this.prefs.path.dir[XC.K.ERROR_LABEL].path);
}//</m>setPathInputSet



//================
this.setSavingDir = function		//<m>void<a>public<d>Setup a directory for saving
(
target,		//<p>string<d>Target editor name (code, output...)
handle		//<p>Object<d>Directory handle
){
this.prefs.path.dir[target] = handle;
this.setPathInputSet();
}//</m>setSavingDir



//================
this.setStoreInput = function		//<m>void<a>private<d>Setup store capacity pref widget
(){
this.controller.setStoreText(this.getElement(XC.K.xul.STORE_CAPACITY_ID), this.prefs.store.capacity);
}//</m>setStoreInput



//================
this.setOutputInput = function		//<m>void<a>private<d>Setup output header pref widget
(){
this.controller.setOutputText(this.getElement(XC.K.xul.OUTPUT_HEADER_ID), this.prefs.output.header);
}//</m>setOutputInput



//================
this.setPreferences = function		//<m>int<a>public<d>Save preferences
(){
try{
	this.getFontInputSet();
	this.getColorInputSet();
	//this.getPathInputSet();
	this.getStoreInput();
	this.getOutputInput();
	this.setUpPrefs(this.prefs);
	return this.K.ERROR.NONE;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.PREFS_SAVING);
	}
}//</m>setPreferences



//================
this.setPref = function		//<m>Object<a>public<d>Set up a specific preference
(
value,		//<p>any<d>Preference value
pref,		//<p>string<d>Preference
property,	//<p>string<d>Preference property
target		//<p>string<d>Target editor name (code, output...) --optional (global pref)
){
if(target) this.prefs[pref][property][target] = value;
else this.prefs[pref][property] = value;
this.setUpPrefs(this.prefs);
}//</m>setPref



//================
this.getPref = function		//<m>Object<a>public<d>Get a specific preference
(
pref,		//<p>string<d>Preference
property,	//<p>string<d>Preference property
target		//<p>string<d>Target editor name (code, output...) --optional (global pref)
){
return target ? this.prefs[pref][property][target] : this.prefs[pref][property];
}//</m>getPref



//================
this.getFontInputSet = function		//<m>void<a>private<d>Get input fonts
(){
this.prefs.font.name[XC.K.CODE_LABEL]	= this.controller.getFontName(this.getElement(XC.K.xul.CODE_FONT_NAME_ID));
//this.prefs.font.name[XC.K.OUT_LABEL]	= this.controller.getFontName(this.getElement(XC.K.xul.OUT_FONT_NAME_ID));
this.prefs.font.name[XC.K.ERROR_LABEL]	= this.controller.getFontName(this.getElement(XC.K.xul.ERROR_FONT_NAME_ID));

this.prefs.font.size[XC.K.CODE_LABEL]	= this.controller.getFontSize(this.getElement(XC.K.xul.CODE_FONT_SIZE_ID));
//this.prefs.font.size[XC.K.OUT_LABEL]	= this.controller.getFontSize(this.getElement(XC.K.xul.OUT_FONT_SIZE_ID));
this.prefs.font.size[XC.K.ERROR_LABEL]	= this.controller.getFontSize(this.getElement(XC.K.xul.ERROR_FONT_SIZE_ID));
}//</m>getFontInputSet



//================
this.getColorInputSet = function		//<m>void<a>private<d>Get input colors
(){
this.prefs.color.bg[XC.K.CODE_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.CODE_COLOR_BG_ID));
//this.prefs.color.bg[XC.K.OUT_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.OUT_COLOR_BG_ID));
this.prefs.color.bg[XC.K.ERROR_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.ERROR_COLOR_BG_ID));

this.prefs.color.fg[XC.K.CODE_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.CODE_COLOR_FG_ID));
//this.prefs.color.fg[XC.K.OUT_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.OUT_COLOR_FG_ID));
this.prefs.color.fg[XC.K.ERROR_LABEL]	= this.controller.getColorpicker(this.getElement(XC.K.xul.ERROR_COLOR_FG_ID));
}//</m>getColorInputSet



//================
this.getPathInputSet = function		//<m>void<a>private<d>Get input paths
(){
/*
Nothing to do
*/
}//</m>getPathInputSet



//================
this.getStoreInput = function		//<m>void<a>private<d>Get input store capacity
(){
var
/*string*/pref = this.controller.getStoreText(this.getElement(XC.K.xul.STORE_CAPACITY_ID));
this.prefs.store.capacity = isNaN(pref) ? this.K.STORE_CAPACITY_DEF : parseInt(pref);
}//</m>getStoreInput



//================
this.getOutputInput = function		//<m>void<a>private<d>Get output header string
(){
this.prefs.output.header = this.controller.getOutputText(this.getElement(XC.K.xul.OUTPUT_HEADER_ID));
}//</m>getOutputInput



//================
this.getStoreURL = function		//<m>string<a>private<d>Get store file URL from user profile directory
(){
try{
	var
	/*string*/profileDir = this.mediator.getUserProfileDir().path;
	if(!profileDir) throw this.K.ERROR.STORE_SETTING;
	var
	/*string*/pathSeparator = (profileDir.indexOf('\\') != -1) ? '\\' :
		(profileDir.indexOf(':') != -1) ? ':' : '/';
	return profileDir + pathSeparator + XC.K.STORE_LEAF;
	}
catch(e){
	this.errorNotifier.setOut('EXCEPTION: ', e);
	return '';
	}
}//</m>getStoreURL



//================
this.getPreferences = function		//<m>Object<a>private<d>Get all preferences
(){
try{
	var
	/*string*/target,
	/*Object*/branch;
	for(var i=0,m=XC.K.EDITOR_SET.length;i<m;i++){
		target = XC.K.EDITOR_SET[i];
		branch = this.service.getBranch(this.getBranchRoot(this.K.FONT_BRANCH, target));
		this.prefs.font.name[target] = branch.getCharPref(this.K.FONT_NAME);
		this.prefs.font.size[target] = branch.getCharPref(this.K.FONT_SIZE);
		branch = this.service.getBranch(this.getBranchRoot(this.K.COLOR_BRANCH, target));
		this.prefs.color.bg[target] = branch.getCharPref(this.K.COLOR_BG);
		this.prefs.color.fg[target] = branch.getCharPref(this.K.COLOR_FG);
		branch = this.service.getBranch(this.getBranchRoot(this.K.PATH_BRANCH, target));
		this.prefs.path.dir[target] = branch.getComplexValue(this.K.PATH_DIR, this.localFile);
		}	//---for
	branch = this.service.getBranch(this.getBranchRoot(this.K.STORE_BRANCH, XC.K.CODE_LABEL));
	this.prefs.store.capacity = branch.getIntPref(this.K.STORE_CAPACITY);
	this.prefs.store.url = branch.getCharPref(this.K.STORE_URL);
	branch = this.service.getBranch(this.getBranchRoot(this.K.OUTPUT_BRANCH, XC.K.OUT_LABEL));
	this.prefs.output.header = branch.getCharPref(this.K.OUTPUT_HEADER);
	branch = this.service.getBranch(this.getBranchRoot(this.K.CODE_BRANCH));
	//this.prefs.code.url = branch.getComplexValue(this.K.CODE_URL, this.localFile);
	this.prefs.code.url = branch.getCharPref(this.K.CODE_URL);
	this.prefs.code.loading = branch.getBoolPref(this.K.CODE_LOADING);
	branch = this.service.getBranch(this.getBranchRoot(this.K.VERSION_BRANCH));
	this.prefs.version.release = branch.getCharPref(this.K.VERSION_RELEASE);
	return this.prefs;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.PREFS_SETTING);
	return null;
	}
}//</m>getPreferences



//================
this.getBrowserPrefs = function		//<m>Object<a>private<d>Get browser preferences
(){
try{
	var
	/*Object*/prefs = new Object(),
	/*Object*/branch = this.service.getBranch(this.K.BROWSER_FONT_MONO);
	prefs.font = branch ? branch.getCharPref(this.K.LANG_GROUP) : this.K.FONT_NAME_DEF;
	branch = this.service.getBranch(this.K.BROWSER_FONT_SIZE);
	prefs.size = branch ? branch.getIntPref(this.K.LANG_GROUP) : this.K.FONT_SIZE_DEF;
	branch = this.service.getBranch(this.K.BROWSER_DISPLAY);
	prefs.bgcolor = branch ? branch.getCharPref(this.K.COLOR_BG) : this.K.COLOR_BG_DEF;
	prefs.fgcolor = branch ? branch.getCharPref(this.K.COLOR_FG) : this.K.COLOR_FG_DEF;
	return prefs;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.BROWSER_PREFS);
	return null;
	}
}//</m>getBrowserPrefs



//================
this.getBrowserLocale = function		//<m>Object<a>private<d>Get browser locale preference
(){
try{
	var
	branch = this.service.getBranch(this.K.BROWSER_LOCALE),
	lang = branch ? branch.getCharPref(this.K.BROWSER_LANG) : this.K.LANG_NAME_DEF;
	if(!(lang in this.prefs.version.langSet)) lang = this.K.LANG_NAME_DEF;
	return lang;
	}
catch(e){
	this.errorNotifier.setOut(e, this.K.ERROR.BROWSER_PREFS);
	return this.K.LANG_NAME_DEF;
	}
}//</m>getBrowserLocale



//================
this.getBranchRoot = function		//<m>string<a>private<d>Get branch root
(
domain,		//<p>string<d>Preference domain (font, color...)
target		//<p>string<d>Target editor name (code, output...)
){
var
/*string*/branch = this.K.PREFS_ROOT + '.' + domain;
if(target) branch += '.' + target;
return branch;
}//</m>getBranchRoot



//================
this.getElement = function		//<m>Object<a>private<d>Get XUL element node
(
id		//<p>string<d>XUL element ID
){
return this.mediator.dom.getElement(id);
}//</m>getElement



//================
this.testPrefsSetting = function		//<m>int<a>private<d>Check whether preferences have already been set
(){
try{
	var
	/*Object*/branch = this.service.getBranch(this.getBranchRoot(this.K.VERSION_BRANCH));
	if(!branch.getPrefType(this.K.VERSION_RELEASE)) return this.K.DEFAULT_SETTING;
	return (branch.getCharPref(this.K.VERSION_RELEASE) == XC.K.APP_VERSION) ? this.K.NO_SETTING : this.K.UPDATE_SETTING;
	}
catch(e){
	return this.errorNotifier.setOut(e, this.K.ERROR.SERVICE_ACCESS);
	}
}//</m>testPrefsSetting



this.K =
	{
	DEFAULT_SETTING:			0,								//1st XUL Console install
	NO_SETTING:					1,								//XUL Console already installed
	UPDATE_SETTING:				-1,								//Previous XUL Console release installed
		
	BROWSER_LOCALE:				'general.useragent',
	BROWSER_LANG:				'.locale',
	BROWSER_DISPLAY:			'browser.display',
	BROWSER_FONT_SIZE:			'font.size.fixed',
	BROWSER_FONT_MONO:			'font.name.monospace',
	LANG_GROUP:					'.x-western',

	PREFS_ROOT:					'xulconsole.mozdev',
	VERSION_BRANCH:				'version',						//version
	VERSION_RELEASE:			'.release',
	FONT_BRANCH:				'font',							//fonts
	FONT_NAME:					'.name',
	FONT_SIZE:					'.size',
	COLOR_BRANCH:				'display',						//colors
	COLOR_BG:					'.background_color',
	COLOR_FG:					'.foreground_color',
	PATH_BRANCH:				'path',							//paths
	PATH_DIR:					'.dir',
	STORE_BRANCH:				'store',						//store
	STORE_CAPACITY:				'.capacity',
	STORE_URL:					'.url',
	OUTPUT_BRANCH:				'output',						//output
	OUTPUT_HEADER:				'.header',
	CODE_BRANCH:				'code',							//code
	CODE_URL:					'.url',
	CODE_LOADING:				'.loading',

	LANG_NAME_DEF:				'en-US',
	FONT_NAME_DEF:				'monospace',
	FONT_SIZE_DEF:				'12',
	COLOR_BG_DEF:				'#ffffff',
	COLOR_FG_DEF:				'#000000',
	STORE_CAPACITY_DEF:			100,
	OUTPUT_HEADER_DEF:			'************************ `__GETDATE__();` ************************',
	CODE_LOADING_DEF:			true,

	ERROR:
		{
		//NON FATAL
		NONE:					0,
		NO_SUCCESS:				1,

		//FATAL
		SERVICE_ACCESS:			-1,
		BRANCH_ACCESS:			-2,
		PREFS_SETTING:			-3,
		STORE_SETTING:			-4,
		BROWSER_PREFS:			-5,
		PREFS_SAVING:			-6,
		FATAL:					0xFF		//end of error codes
		}
	};



this.PREFS_Monitor(_mediator);
}//</c>PREFS_Monitor



